;;; -*- Mode: Lisp; Syntax: ANSI-Common-Lisp; Base: 10; -*-
;;;
;;; dimacs.lisp --- DIMACS read/write procedures

;; Copyright (C) 2010 Utz-Uwe Haus <lisp@uuhaus.de>
;; $Id:$
;; This code is free software; you can redistribute it and/or modify
;; it under the terms of the version 3 of the GNU General
;; Public License as published by the Free Software Foundation, as
;; clarified by the prequel found in LICENSE.Lisp-GPL-Preface.
;;
;; This code is distributed in the hope that it will be useful, but
;; without any warranty; without even the implied warranty of
;; merchantability or fitness for a particular purpose. See the GNU
;; Lesser General Public License for more details.
;;
;; Version 3 of the GNU General Public License is in the file
;; LICENSE.GPL that was distributed with this file. If it is not
;; present, you can access it from
;; http://www.gnu.org/copyleft/gpl.txt (until superseded by a
;; newer version) or write to the Free Software Foundation, Inc., 59
;; Temple Place, Suite 330, Boston, MA 02111-1307 USA
;;
;; Commentary:

;; 

;;; Code:

(eval-when (:compile-toplevel :load-toplevel)
  (declaim (optimize (speed 3) (debug 1) (safety 1))))

(in-package #:satwrap)

(defun split-delimited-string (string char)
  "Return a list of the substrings of STRING that are separated by CHAR. Without CHAR."
  (declare (type string string)
           (type character char))
  (let ((res '()))
    (loop :as last-pos := 0 :then (1+ next-pos)
       :as next-pos := (position char string :start last-pos :test #'char=)
       :while next-pos
       :do (push (subseq string last-pos next-pos) res)
       :finally (push (subseq string last-pos) res))
    (nreverse res)))

(defgeneric read-dimacs (solver source)
  (:documentation "Read DIMACS-style sat problem from SOURCE into SOLVER.")
  (:method ((solver sat-solver) (source pathname))
    (with-open-file (f source :direction :input)
      (loop :as line := (read-line f nil nil nil)
	 :as pieces := (and line
			    (split-delimited-string line #\Space))
	 :while line
	 :when (string= "p" (first pieces))
	 ;; format specification:
	 :do (destructuring-bind (p format m n)
		 pieces
	       (declare (ignore p))
	       (unless (string= "cnf" format)
		 (error "Dimacs file not in CNF format: ~A" line))
	       (setf (sat-solver-numvars solver) (parse-integer m))
	       (loop 
		  :with clause := '()
		  :as var := (read f nil nil nil)
		  :while var
		  :if (= 0 var)
		  :do (progn 
			(add-clause solver (nreverse clause))
			(setf clause '()))
		  :else
		  :collect (push var clause))
	       (unless (= (parse-integer n) (sat-solver-numclauses solver))
		 (error "Dimacs file ends prematurely: parsed ~D clauses, expected ~A"
			(sat-solver-numclauses solver)
			n)))))
    (setf (sat-solver-new-clauses solver) (nreverse (sat-solver-new-clauses solver)))
    solver))

(defgeneric write-dimacs (solver dst &key comments)
  (:documentation "Write DIMACS-STYLE sat problem of SOLVER to DST.")
  (:method ((solver sat-solver) (dst pathname) &key (comments "Generated by cl-satwrap"))
    (with-open-file (f dst :direction :output :if-exists :supersede)
      ;; See CLHS 22.3.3. example:
      (format f "~&c ~{~<~%c ~1:;~A~>~^ ~}~%" (split-delimited-string comments #\Space))
      (format f "~&p cnf ~D ~D~%" 
	      (sat-solver-numvars solver)
	      (sat-solver-numclauses solver))
      (format f "~{~&~{~D~^ ~} 0~%~}" (sat-solver-old-clauses solver))
      (format f "~{~&~{~D~^ ~} 0~%~}" (sat-solver-new-clauses solver)))))

(defun make-sat-solver-for-dimacs-instance (source)
  (read-dimacs (make-instance 'sat-solver) source))